using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace GGC_Sorting
{
	public class Form1 : System.Windows.Forms.Form
	{
	    #region Constants
	    private const string ColumnLookupFirst = "LookupFirst_Name";
	    private const string ColumnLookupSecond = "LookupSecond_Name";
	    #endregion
	    
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private LookupCollection lookupCollectionFirst;
		private LookupCollection lookupCollectionSecond;
        private System.Windows.Forms.Label lblName;
        private System.Windows.Forms.TextBox txtName;
        private System.Windows.Forms.TextBox txtEntityId;
        private System.Windows.Forms.Label lblEntityId;
        private System.Windows.Forms.Label lblLookupFirst;
        private System.Windows.Forms.Label lblLookupSecond;
        private System.Windows.Forms.ComboBox cboLookupFirst;
        private System.Windows.Forms.ComboBox cboLookupSecond;
        private System.Windows.Forms.CheckBox chkIsActive;
        private System.Windows.Forms.CheckBox chkIsVisible;
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl grdPrimary;
        
		private EntityCollection entityCollection;
		public EntityCollection Entities
		{
		    get
		    {
		        return this.entityCollection;
		    }
		    set
		    {
		        this.entityCollection = value;
		    }
		}
		
		public Record SelectedEntityRecord
		{
		    get
		    {
		        return this.GetSelectedRecord(this.grdPrimary);
		    }
		}
		
		public Entity SelectedEntity
		{
		    get
		    {
		        Record selectedRecord = this.SelectedEntityRecord;
		        if (selectedRecord == null)
		            return null;
		            
		        return selectedRecord.GetData() as Entity;
		    }
		}

        #region Constructors
		public Form1()
		{
			// Required for Windows Form Designer support
			InitializeComponent();
		}
		#endregion

        #region Clean Up
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.lblName = new System.Windows.Forms.Label();
            this.txtName = new System.Windows.Forms.TextBox();
            this.txtEntityId = new System.Windows.Forms.TextBox();
            this.lblEntityId = new System.Windows.Forms.Label();
            this.lblLookupFirst = new System.Windows.Forms.Label();
            this.lblLookupSecond = new System.Windows.Forms.Label();
            this.cboLookupFirst = new System.Windows.Forms.ComboBox();
            this.cboLookupSecond = new System.Windows.Forms.ComboBox();
            this.chkIsActive = new System.Windows.Forms.CheckBox();
            this.chkIsVisible = new System.Windows.Forms.CheckBox();
            this.grdPrimary = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            ((System.ComponentModel.ISupportInitialize)(this.grdPrimary)).BeginInit();
            this.SuspendLayout();
            // 
            // lblName
            // 
            this.lblName.Location = new System.Drawing.Point(24, 264);
            this.lblName.Name = "lblName";
            this.lblName.TabIndex = 1;
            this.lblName.Text = "Name";
            // 
            // txtName
            // 
            this.txtName.Location = new System.Drawing.Point(128, 264);
            this.txtName.Name = "txtName";
            this.txtName.Size = new System.Drawing.Size(136, 20);
            this.txtName.TabIndex = 2;
            this.txtName.Text = "";
            // 
            // txtEntityId
            // 
            this.txtEntityId.Location = new System.Drawing.Point(128, 240);
            this.txtEntityId.Name = "txtEntityId";
            this.txtEntityId.ReadOnly = true;
            this.txtEntityId.Size = new System.Drawing.Size(64, 20);
            this.txtEntityId.TabIndex = 4;
            this.txtEntityId.Text = "";
            // 
            // lblEntityId
            // 
            this.lblEntityId.Location = new System.Drawing.Point(24, 240);
            this.lblEntityId.Name = "lblEntityId";
            this.lblEntityId.TabIndex = 3;
            this.lblEntityId.Text = "Id";
            // 
            // lblLookupFirst
            // 
            this.lblLookupFirst.Location = new System.Drawing.Point(24, 288);
            this.lblLookupFirst.Name = "lblLookupFirst";
            this.lblLookupFirst.TabIndex = 5;
            this.lblLookupFirst.Text = "First Lookup";
            // 
            // lblLookupSecond
            // 
            this.lblLookupSecond.Location = new System.Drawing.Point(24, 312);
            this.lblLookupSecond.Name = "lblLookupSecond";
            this.lblLookupSecond.TabIndex = 6;
            this.lblLookupSecond.Text = "Second Lookup";
            // 
            // cboLookupFirst
            // 
            this.cboLookupFirst.Location = new System.Drawing.Point(128, 288);
            this.cboLookupFirst.Name = "cboLookupFirst";
            this.cboLookupFirst.Size = new System.Drawing.Size(136, 21);
            this.cboLookupFirst.TabIndex = 7;
            // 
            // cboLookupSecond
            // 
            this.cboLookupSecond.Location = new System.Drawing.Point(128, 312);
            this.cboLookupSecond.Name = "cboLookupSecond";
            this.cboLookupSecond.Size = new System.Drawing.Size(136, 21);
            this.cboLookupSecond.TabIndex = 8;
            // 
            // chkIsActive
            // 
            this.chkIsActive.Location = new System.Drawing.Point(24, 336);
            this.chkIsActive.Name = "chkIsActive";
            this.chkIsActive.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
            this.chkIsActive.Size = new System.Drawing.Size(120, 24);
            this.chkIsActive.TabIndex = 9;
            this.chkIsActive.Text = "Is Active";
            this.chkIsActive.TextAlign = System.Drawing.ContentAlignment.TopRight;
            this.chkIsActive.Visible = false;
            // 
            // chkIsVisible
            // 
            this.chkIsVisible.Location = new System.Drawing.Point(24, 360);
            this.chkIsVisible.Name = "chkIsVisible";
            this.chkIsVisible.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
            this.chkIsVisible.Size = new System.Drawing.Size(120, 24);
            this.chkIsVisible.TabIndex = 10;
            this.chkIsVisible.Text = "Is Visible";
            this.chkIsVisible.TextAlign = System.Drawing.ContentAlignment.TopRight;
            this.chkIsVisible.Visible = false;
            // 
            // grdPrimary
            // 
            this.grdPrimary.BackColor = System.Drawing.SystemColors.Window;
            this.grdPrimary.Location = new System.Drawing.Point(16, 16);
            this.grdPrimary.Name = "grdPrimary";
            this.grdPrimary.Size = new System.Drawing.Size(680, 208);
            this.grdPrimary.TabIndex = 11;
            this.grdPrimary.VersionInfo = "4.101.0.58";
            this.grdPrimary.SelectedRecordsChanging += new Syncfusion.Grouping.SelectedRecordsChangedEventHandler(this.grdPrimary_SelectedRecordsChanging);
            this.grdPrimary.SelectedRecordsChanged += new Syncfusion.Grouping.SelectedRecordsChangedEventHandler(this.grdPrimary_SelectedRecordsChanged);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(712, 518);
            this.Controls.Add(this.grdPrimary);
            this.Controls.Add(this.chkIsVisible);
            this.Controls.Add(this.chkIsActive);
            this.Controls.Add(this.cboLookupSecond);
            this.Controls.Add(this.cboLookupFirst);
            this.Controls.Add(this.lblLookupSecond);
            this.Controls.Add(this.lblLookupFirst);
            this.Controls.Add(this.txtEntityId);
            this.Controls.Add(this.lblEntityId);
            this.Controls.Add(this.txtName);
            this.Controls.Add(this.lblName);
            this.Name = "Form1";
            this.Text = "Form1";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.grdPrimary)).EndInit();
            this.ResumeLayout(false);

        }
		#endregion

        #region Event Handlers
        private void Form1_Load(object sender, System.EventArgs e)
        {
            this.lookupCollectionFirst = this.GetSampleLookupCollectionFirst();
            this.lookupCollectionSecond = this.GetSampleLookupCollectionSecond();
            this.entityCollection = this.GetSampleEntityCollection();
            
            this.BindDropDownLists();
            this.InitializeGridLayout();
            this.grdPrimary.DataSource = this.entityCollection;
            this.SetSelectedRecord(this.grdPrimary, 0, true);
            this.SetDataBindings();
        }

        private void grdPrimary_SelectedRecordsChanged(object sender, Syncfusion.Grouping.SelectedRecordsChangedEventArgs e)
        {
            if (this.SelectedEntity != null)
            {
//                ListChangedEventArgs listChanged = new ListChangedEventArgs(ListChangedType.ItemChanged, e.SelectedRecord.Record.GetSourceIndex());
//                this.grdPrimary.Table.SimulateListChanged(listChanged);
                Console.WriteLine("Break");
            }
        }

        private void grdPrimary_SelectedRecordsChanging(object sender, Syncfusion.Grouping.SelectedRecordsChangedEventArgs e)
        {
//            if ((e.Action == SelectedRecordsChangedType.Added) && (e.Table.SelectedRecords.Count == 1))
//            {
//                SelectedRecord record = e.Table.SelectedRecords[0];
//                GridCurrentCell currentCell = this.grdPrimary.TableControl.CurrentCell;
//                currentCell.MoveTo(currentCell.RowIndex, currentCell.ColIndex);
//                e.Cancel = true;
//            }
        }
        #endregion
        
        #region Miscellaneous Methods
        private void BindDropDownLists()
        {
            this.lookupCollectionFirst.Insert(0, new Lookup());
            this.cboLookupFirst.DisplayMember = Lookup.PropertyCode;
            this.cboLookupFirst.DataSource = this.lookupCollectionFirst;
            
            this.lookupCollectionSecond.Insert(0, new Lookup());
            this.cboLookupSecond.DisplayMember = Lookup.PropertyCode;
            this.cboLookupSecond.DataSource = this.lookupCollectionSecond;
        }
        
        private void SetDataBindings()
        {
            this.txtEntityId.DataBindings.Add("Text", this.Entities, Entity.PropertyEntityId);
            this.txtName.DataBindings.Add("Text", this.Entities, Entity.PropertyName);
            this.cboLookupFirst.DataBindings.Add("SelectedItem", this.Entities, Entity.PropertyLookupFirst);
            this.cboLookupSecond.DataBindings.Add("SelectedItem", this.Entities, Entity.PropertyLookupSecond);
//            this.chkIsActive.DataBindings.Add("Checked", this.Entities, Entity.PropertyIsActive);
//            this.chkIsVisible.DataBindings.Add("Checked", this.Entities, Entity.PropertyIsVisible);
        }
        #endregion
        
        #region Grid Initialization Methods
        private void InitializeGridLayout()
        {
            this.grdPrimary.TableModel.Properties.RowHeaders = false;
            this.grdPrimary.TopLevelGroupOptions.ShowCaption = false;
            this.DisableAddNewRecordAllLevels();

            // standard style for single selection, read-only
            this.ApplyStyleReadOnlySingleSelect();
            this.InitializeGridColumns();
        }

        private void DisableAddNewRecordAllLevels()
        {
            this.grdPrimary.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.grdPrimary.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = false;
            this.grdPrimary.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.grdPrimary.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = false;
            this.grdPrimary.ChildGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.grdPrimary.ChildGroupOptions.ShowAddNewRecordAfterDetails = false;
        }

        private void ApplyStyleReadOnlySingleSelect()
        {
            this.grdPrimary.TableOptions.AllowSortColumns = true;
            this.grdPrimary.TableOptions.AllowSelection = GridSelectionFlags.None;
            this.grdPrimary.TableOptions.ListBoxSelectionMode = SelectionMode.One;
            this.grdPrimary.TableOptions.ListBoxSelectionCurrentCellOptions = GridListBoxSelectionCurrentCellOptions.None;
            this.grdPrimary.TopLevelGroupOptions.ShowCaption = false;
            this.grdPrimary.TableDescriptor.Appearance.RecordFieldCell.CellType = "Static";
            this.grdPrimary.TableDescriptor.Appearance.AlternateRecordFieldCell.CellType = "Static";
            this.grdPrimary.TableDescriptor.Appearance.AnyRecordFieldCell.ReadOnly = true;
        }
        
        private void InitializeGridColumns()
        {
            GridTableDescriptor table = this.grdPrimary.TableDescriptor;
            table.Columns.Clear();
			
            // id
            GridColumnDescriptor column = new GridColumnDescriptor(Entity.PropertyEntityId,
                Entity.PropertyEntityId, "Id");
            column.Width = 80;
            table.Columns.Add(column);
            
            // name
            column = new GridColumnDescriptor(Entity.PropertyName,
                Entity.PropertyName, "Name");
            column.Width = 100;
            column.Appearance.AnyRecordFieldCell.CellType = Constants.GridCellTypeStatic;
            table.Columns.Add(column);
			
            // lookup first
            column = new GridColumnDescriptor(Form1.ColumnLookupFirst,
                Form1.ColumnLookupFirst, "First Lookup");
            column.Width = 100;
            column.Appearance.AnyRecordFieldCell.CellType = Constants.GridCellTypeStatic;
            table.Columns.Add(column);
			
            // lookup second
            column = new GridColumnDescriptor(Form1.ColumnLookupSecond,
                Form1.ColumnLookupSecond, "Second Lookup");
            column.Width = 100;
            column.Appearance.AnyRecordFieldCell.CellType = Constants.GridCellTypeStatic;
            table.Columns.Add(column);

            // is active
            column = new GridColumnDescriptor(Entity.PropertyIsActive,
                Entity.PropertyIsActive, "Is Active");
            column.Appearance.AnyRecordFieldCell.CellType = Constants.GridCellTypeCheckBox;
            column.Appearance.AnyRecordFieldCell.HorizontalAlignment = GridHorizontalAlignment.Center;
            column.Width = 100;
            column.Appearance.AnyRecordFieldCell.ReadOnly = false;
            table.Columns.Add(column);

            // is visible
            column = new GridColumnDescriptor(Entity.PropertyIsVisible,
                Entity.PropertyIsVisible, "Is Visible");
            column.Appearance.AnyRecordFieldCell.CellType = Constants.GridCellTypeCheckBox;
            column.Appearance.AnyRecordFieldCell.HorizontalAlignment = GridHorizontalAlignment.Center;
            column.Width = 100;
            column.Appearance.AnyRecordFieldCell.ReadOnly = false;
            table.Columns.Add(column);

            // set column sorting
            if (!table.SortedColumns.Contains(Entity.PropertyIsActive))
            {
                table.SortedColumns.Add(Entity.PropertyIsActive, ListSortDirection.Descending);
            }
            if (!table.SortedColumns.Contains(Entity.PropertyIsVisible))
            {
                table.SortedColumns.Add(Entity.PropertyIsVisible, ListSortDirection.Descending);
            }
            if (!table.SortedColumns.Contains(Form1.ColumnLookupFirst))
            {
                table.SortedColumns.Add(Form1.ColumnLookupFirst, ListSortDirection.Ascending);
            }
            if (!table.SortedColumns.Contains(Form1.ColumnLookupSecond))
            {
                table.SortedColumns.Add(Form1.ColumnLookupSecond, ListSortDirection.Ascending);
            }
        }
        #endregion
        
        #region Get Data Methods
        private EntityCollection GetSampleEntityCollection()
        {
            EntityCollection collection = new EntityCollection();
            
            Entity entity = new Entity();
            entity.EntityId = 1;
            entity.Name = "First Entity";
            entity.LookupFirst = this.lookupCollectionFirst[0];
            entity.LookupSecond = this.lookupCollectionSecond[0];
            collection.Add(entity);

            entity = new Entity();
            entity.EntityId = 2;
            entity.Name = "Second Entity";
            entity.LookupFirst = this.lookupCollectionFirst[1];
            entity.LookupSecond = this.lookupCollectionSecond[1];
            collection.Add(entity);

            entity = new Entity();
            entity.EntityId = 3;
            entity.Name = "Third Entity";
            entity.LookupFirst = this.lookupCollectionFirst[2];
            entity.LookupSecond = this.lookupCollectionSecond[2];
            collection.Add(entity);

            entity = new Entity();
            entity.EntityId = 4;
            entity.Name = "Fourth Entity";
            entity.LookupFirst = this.lookupCollectionFirst[3];
            entity.LookupSecond = this.lookupCollectionSecond[3];
            collection.Add(entity);

            entity = new Entity();
            entity.EntityId = 5;
            entity.Name = "Fifth Entity";
            entity.LookupFirst = this.lookupCollectionFirst[4];
            entity.LookupSecond = this.lookupCollectionSecond[4];
            collection.Add(entity);
            
            return collection;
        }
        
        private LookupCollection GetSampleLookupCollectionFirst()
        {
            LookupCollection collection = new LookupCollection();
            
            Lookup lookup = new Lookup();
            lookup.LookupId = 1;
            lookup.Code = "AAA";
            lookup.Name = "AAA Lookup";
            collection.Add(lookup);

            lookup = new Lookup();
            lookup.LookupId = 2;
            lookup.Code = "BBB";
            lookup.Name = "BBB Lookup";
            collection.Add(lookup);

            lookup = new Lookup();
            lookup.LookupId = 3;
            lookup.Code = "CCC";
            lookup.Name = "CCC Lookup";
            collection.Add(lookup);

            lookup = new Lookup();
            lookup.LookupId = 4;
            lookup.Code = "DDD";
            lookup.Name = "DDD Lookup";
            collection.Add(lookup);

            lookup = new Lookup();
            lookup.LookupId = 5;
            lookup.Code = "EEE";
            lookup.Name = "EEE Lookup";
            collection.Add(lookup);
            
            return collection;
        }
        
        private LookupCollection GetSampleLookupCollectionSecond()
        {
            LookupCollection collection = new LookupCollection();
            
            Lookup lookup = new Lookup();
            lookup.LookupId = 6;
            lookup.Code = "FFF";
            lookup.Name = "FFF Lookup";
            collection.Add(lookup);

            lookup = new Lookup();
            lookup.LookupId = 7;
            lookup.Code = "GGG";
            lookup.Name = "GGG Lookup";
            collection.Add(lookup);

            lookup = new Lookup();
            lookup.LookupId = 8;
            lookup.Code = "HHH";
            lookup.Name = "HHH Lookup";
            collection.Add(lookup);

            lookup = new Lookup();
            lookup.LookupId = 9;
            lookup.Code = "III";
            lookup.Name = "III Lookup";
            collection.Add(lookup);

            lookup = new Lookup();
            lookup.LookupId = 10;
            lookup.Code = "JJJ";
            lookup.Name = "JJJ Lookup";
            collection.Add(lookup);
            
            return collection;
        }
        #endregion
        
        #region Grid Helper Methods
        public Record GetSelectedRecord(GridGroupingControl grid)
        {
            SelectedRecordsCollection records = grid.Table.SelectedRecords;
            if ((records == null) || (records.Count == 0))
                return null;
				
            // we need to get a handle to the first "real" record from the collection
            // i.e. we want to skip things like headers, "add new row" items, etc.
            Record targetRecord = null;
            foreach (SelectedRecord selectedRecord in records)
            {
                if (selectedRecord.Record.Kind == DisplayElementKind.Record)
                {
                    targetRecord = selectedRecord.Record;
                    break;
                }
            }
            return targetRecord;
        }

        public void SetSelectedRecord(GridGroupingControl grid, int index, bool setCurrent)
        {
            grid.Table.SelectedRecords.Clear();
            grid.Table.SelectedRecords.Add(grid.Table.Records[index]);
			
            if (grid.CurrencyManager != null)
            {
                grid.CurrencyManager.Refresh();
            }

            if (setCurrent == true)
            {
                grid.Table.Records[index].SetCurrent();
            }
        }
        #endregion
	}
}
